config/routes.rb
Rails.application.routes.draw do
  get 'welcome/index'

	resources :articles do
		resources :comments
		resources :ratings
	end

  root 'welcome#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/article.rb
class Article < ApplicationRecord
	has_many :comments, dependent: :destroy
	has_many :ratings, dependent: :destroy
	validates :title, presence: true, length: { minimum: 5 }
end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :article
end

app/models/rating.rb
class Rating < ApplicationRecord
  belongs_to :article
  validates :value, presence: true, numericality: { only_integer: true, 
  													greater_than_or_equal_to: 1, 
													less_than_or_equal_to: 4 }
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/articles_controller.rb
class ArticlesController < ApplicationController	
	def index
		@articles = Article.all
	end

	def show
		@article = Article.find(params[:id])
	end

	def new
		@article = Article.new
	end

	def edit
		@article = Article.find(params[:id])
	end

	def create
		@article = Article.new(article_params)
 
		if @article.save
			redirect_to @article
		else
			render 'new'
		end
  	end

  	def update
		@article = Article.find(params[:id])

		if @article.update(article_params)
			redirect_to @article
		else
			render 'edit'
		end
	end

	def destroy
		@article = Article.find(params[:id])
		@article.destroy

		redirect_to articles_path
	end

  	private
		def article_params
			params.require(:article).permit(:title, :text)
		end
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
	def create
		@article = Article.find(params[:article_id])
		@comment = @article.comments.create(comment_params)
		redirect_to article_path(@article)
	end

	def destroy
		@article = Article.find(params[:article_id])
		@comment = @article.comments.find(params[:id])
		@comment.destroy
		redirect_to article_path(@article)
	end

	private
		def comment_params
			params.require(:comment).permit(:commenter, :body)
		end
end

app/controllers/ratings_controller.rb
class RatingsController < ApplicationController
	def index
		@article = Article.find(params[:article_id])
		@ratings = @article.ratings.group(:value).count
	end

	def create
		@article = Article.find(params[:article_id])

		ratingValue = 0
		chosenRating = params[:rating_value]

		case chosenRating
		when "Nuda"
		   ratingValue = 1
		when "To se mi líbí"
			ratingValue = 2
		when "Málo detailů"
			ratingValue = 3
		when "Příliš mnoho detailů"
			ratingValue = 4
		end

		@rating = @article.ratings.create(value: ratingValue)
		redirect_to article_path(@article)
	end
end

app/controllers/welcome_controller.rb
class WelcomeController < ApplicationController
  def index
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/articles_helper.rb
module ArticlesHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/ratings_helper.rb
module RatingsHelper
end

app/helpers/welcome_helper.rb
module WelcomeHelper
end

app/views/articles/_form.html.erb
<%= form_with model: @article, local: true do |form| %>
 
  <% if @article.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@article.errors.count, "error") %> prohibited
        this article from being saved:
      </h2>
      <ul>
        <% @article.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
 
  <p>
    <%= form.label :title %><br>
    <%= form.text_field :title %>
  </p>
 
  <p>
    <%= form.label :text %><br>
    <%= form.text_area :text %>
  </p>
 
  <p>
    <%= form.submit %>
  </p>
 
<% end %>

app/views/articles/edit.html.erb
<h1>Edit Article</h1>

<%= render 'form' %>

<%= link_to 'Back', articles_path %>

app/views/articles/index.html.erb
<h1>Listing Articles</h1>
 
<%= link_to 'New article', new_article_path %>
<table>
  <tr>
    <th>Title</th>
    <th>Text</th>
    <th colspan="3"></th>
  </tr>
 
  <% @articles.each do |article| %>
    <tr>
      <td><%= article.title %></td>
      <td><%= article.text %></td>
      <td><%= link_to 'Show', article_path(article) %></td>
      <td><%= link_to 'Edit', edit_article_path(article) %></td>
      <td><%= link_to 'Destroy', article_path(article),
              method: :delete,
              data: { confirm: 'Are you sure?' } %></td>
    </tr>
  <% end %>
</table>

app/views/articles/new.html.erb
<h1>New Article</h1>

<%= render 'form' %>

<%= link_to 'Back', articles_path %>

app/views/articles/show.html.erb
<p>
  <strong>Title:</strong>
  <%= @article.title %>
</p>
 
<p>
  <strong>Text:</strong>
  <%= @article.text %>
</p>

<h2>Give a Rating</h2>
<%= render 'ratings/form' %>

<h2>Comments</h2>
<%= render @article.comments %>

<h2>Add a comment:</h2>
<%= render 'comments/form' %>

<%= link_to 'Edit', edit_article_path(@article) %> |
<%= link_to 'Back', articles_path %>
<%= link_to 'Ratings statistics', article_ratings_path(@article) %>

app/views/comments/_comment.html.erb
<p>
  <strong>Commenter:</strong>
  <%= comment.commenter %>
</p>
 
<p>
  <strong>Comment:</strong>
  <%= comment.body %>
</p>
<p>
  <%= link_to 'Destroy Comment', [comment.article, comment],
               method: :delete,
               data: { confirm: 'Are you sure?' } %>
</p>

app/views/comments/_form.html.erb
<%= form_with(model: [ @article, @article.comments.build ], local: true) do |form| %>
  <p>
    <%= form.label :commenter %><br>
    <%= form.text_field :commenter %>
  </p>
  <p>
    <%= form.label :body %><br>
    <%= form.text_area :body %>
  </p>
  <p>
    <%= form.submit %>
  </p>
<% end %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>App</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/ratings/_form.html.erb
<%= form_with(model: [ @article, @article.ratings.build ], local: true) do |form| %>
  <p>
    <%= form.submit "Nuda", name: 'rating_value' %>
    <%= form.submit "To se mi líbí", name: 'rating_value' %>
    <%= form.submit "Málo detailů", name: 'rating_value' %>
    <%= form.submit "Příliš mnoho detailů", name: 'rating_value' %>
  </p>
<% end %>

app/views/ratings/index.html.erb
<h1>
	Rating statistics
</h1>
<h2>
	Article <%= @article.title %>
</h2>
<p>
	<table>
		<thead>
			<th>Rating type</th>
			<th>Count</th>
		</thead>
		<tbody>
			<% @ratings.each do |r| %>
			<tr>
				<td>
					<% case r[0] %>
					<% when 1 %>
						Nuda
					<% when 2 %>
						To se mi líbí
					<% when 3 %>
						Málo detailů
					<% when 4 %>
						Příliš mnoho detailů
					<% end %>
				</td>
				<td>
					<%= r[1] %>
				</td>
			</tr>		
			<% end %>
		</tbody>
	</table>
</p>

app/views/welcome/index.html.erb
<h1>Hello Rails!!!</h1>

<%= link_to 'My Blog', controller: 'articles' %>